=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-08-06 00:16:27 +0000
+++ drizzled/drizzled.cc	2010-08-06 17:57:15 +0000
@@ -29,6 +29,8 @@
 #include <limits.h>
 
 #include <boost/program_options.hpp>
+#include <boost/thread/recursive_mutex.hpp>
+#include <boost/thread/mutex.hpp>
 
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/my_bit.h"
@@ -335,7 +337,7 @@
 pthread_mutex_t LOCK_thread_count;
 pthread_mutex_t LOCK_status;
 pthread_mutex_t LOCK_global_read_lock;
-pthread_mutex_t LOCK_global_system_variables;
+boost::recursive_mutex LOCK_global_system_variables;
 
 pthread_cond_t COND_refresh, COND_thread_count, COND_global_read_lock;
 pthread_t signal_thread;
@@ -539,7 +541,6 @@
   (void) pthread_mutex_destroy(&LOCK_open);
   (void) pthread_mutex_destroy(&LOCK_thread_count);
   (void) pthread_mutex_destroy(&LOCK_status);
-  (void) pthread_mutex_destroy(&LOCK_global_system_variables);
   (void) pthread_mutex_destroy(&LOCK_global_read_lock);
   (void) pthread_cond_destroy(&COND_thread_count);
   (void) pthread_cond_destroy(&COND_server_end);
@@ -809,7 +810,6 @@
 
   pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE); 
   (void) pthread_mutex_init(&LOCK_thread_count, &attr);
-  (void) pthread_mutex_init(&LOCK_global_system_variables, &attr);
 
   (void) pthread_mutex_init(&LOCK_status, MY_MUTEX_INIT_FAST);
   (void) pthread_mutex_init(&LOCK_global_read_lock, MY_MUTEX_INIT_FAST);

=== modified file 'drizzled/module/loader.cc'
--- drizzled/module/loader.cc	2010-08-03 19:00:52 +0000
+++ drizzled/module/loader.cc	2010-08-06 17:57:15 +0000
@@ -977,7 +977,7 @@
     session->variables.dynamic_variables_ptr= tmpptr;
 
     if (global_lock)
-      pthread_mutex_lock(&LOCK_global_system_variables);
+      LOCK_global_system_variables.lock();
 
     //safe_mutex_assert_owner(&LOCK_global_system_variables);
 
@@ -1020,7 +1020,7 @@
     }
 
     if (global_lock)
-      pthread_mutex_unlock(&LOCK_global_system_variables);
+      LOCK_global_system_variables.unlock();
 
     session->variables.dynamic_variables_version=
            global_system_variables.dynamic_variables_version;
@@ -1262,7 +1262,7 @@
   if (is_readonly())
     return;
 
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   tgt= real_value_ptr(session, type);
   src= ((void **) (plugin_var + 1) + 1);
 
@@ -1299,11 +1299,11 @@
   if (!(plugin_var->flags & PLUGIN_VAR_SessionLOCAL) || type == OPT_GLOBAL)
   {
     plugin_var->update(session, plugin_var, tgt, src);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
   {
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     plugin_var->update(session, plugin_var, tgt, src);
   }
 }
@@ -1322,18 +1322,18 @@
   if (is_readonly())
     return 1;
 
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   tgt= real_value_ptr(session, var->type);
 
   if (!(plugin_var->flags & PLUGIN_VAR_SessionLOCAL) || var->type == OPT_GLOBAL)
   {
     /* variable we are updating has global scope, so we unlock after updating */
     plugin_var->update(session, plugin_var, tgt, &var->save_result);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
   {
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     plugin_var->update(session, plugin_var, tgt, &var->save_result);
   }
  return 0;

=== modified file 'drizzled/pthread_globals.h'
--- drizzled/pthread_globals.h	2010-08-05 21:15:44 +0000
+++ drizzled/pthread_globals.h	2010-08-06 17:57:15 +0000
@@ -21,6 +21,8 @@
 #define DRIZZLED_PTHREAD_GLOBALS_H
 
 #include <pthread.h>
+#include <boost/thread/recursive_mutex.hpp>
+#include <boost/thread/mutex.hpp>
 
 namespace drizzled
 {
@@ -29,7 +31,7 @@
 extern pthread_mutex_t LOCK_thread_count;
 extern pthread_mutex_t LOCK_status;
 extern pthread_mutex_t LOCK_global_read_lock;
-extern pthread_mutex_t LOCK_global_system_variables;
+extern boost::recursive_mutex LOCK_global_system_variables;
 
 extern pthread_cond_t COND_refresh;
 extern pthread_cond_t COND_thread_count;

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2010-08-03 19:00:52 +0000
+++ drizzled/set_var.cc	2010-08-06 17:57:15 +0000
@@ -504,7 +504,7 @@
 bool sys_var_uint32_t_ptr::update(Session *session, set_var *var)
 {
   uint32_t tmp= var->save_result.uint32_t_value;
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   if (option_limits)
   {
     uint32_t newvalue= (uint32_t) fix_unsigned(session, tmp, option_limits);
@@ -513,7 +513,7 @@
   }
   else
     *value= (uint32_t) tmp;
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
   return 0;
 }
 
@@ -521,17 +521,17 @@
 void sys_var_uint32_t_ptr::set_default(Session *, sql_var_t)
 {
   bool not_used;
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   *value= (uint32_t)getopt_ull_limit_value((uint32_t) option_limits->def_value,
                                            option_limits, &not_used);
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
 }
 
 
 bool sys_var_uint64_t_ptr::update(Session *session, set_var *var)
 {
   uint64_t tmp= var->save_result.uint64_t_value;
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   if (option_limits)
   {
     uint64_t newvalue= (uint64_t) fix_unsigned(session, tmp, option_limits);
@@ -540,7 +540,7 @@
   }
   else
     *value= (uint64_t) tmp;
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
   return 0;
 }
 
@@ -548,22 +548,22 @@
 void sys_var_uint64_t_ptr::set_default(Session *, sql_var_t)
 {
   bool not_used;
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   *value= getopt_ull_limit_value((uint64_t) option_limits->def_value,
                                  option_limits, &not_used);
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
 }
 
 
 bool sys_var_size_t_ptr::update(Session *session, set_var *var)
 {
   size_t tmp= var->save_result.size_t_value;
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   if (option_limits)
     *value= fix_size_t(session, tmp, option_limits);
   else
     *value= tmp;
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
   return 0;
 }
 
@@ -571,10 +571,10 @@
 void sys_var_size_t_ptr::set_default(Session *, sql_var_t)
 {
   bool not_used;
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
   *value= (size_t)getopt_ull_limit_value((size_t) option_limits->def_value,
                                          option_limits, &not_used);
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
 }
 
 bool sys_var_bool_ptr::update(Session *, set_var *var)
@@ -665,9 +665,9 @@
   if (var->type == OPT_GLOBAL)
   {
     /* Lock is needed to make things safe on 32 bit systems */
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset= (ha_rows) tmp;
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= (ha_rows) tmp;
@@ -681,11 +681,11 @@
   {
     bool not_used;
     /* We will not come here if option_limits is not set */
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset=
       (ha_rows) getopt_ull_limit_value((ha_rows) option_limits->def_value,
                                        option_limits, &not_used);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= global_system_variables.*offset;
@@ -722,9 +722,9 @@
   if (var->type == OPT_GLOBAL)
   {
     /* Lock is needed to make things safe on 32 bit systems */
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset= (uint64_t) tmp;
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= (uint64_t) tmp;
@@ -737,11 +737,11 @@
   if (type == OPT_GLOBAL)
   {
     bool not_used;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset=
       getopt_ull_limit_value((uint64_t) option_limits->def_value,
                              option_limits, &not_used);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= global_system_variables.*offset;
@@ -775,9 +775,9 @@
   if (var->type == OPT_GLOBAL)
   {
     /* Lock is needed to make things safe on 32 bit systems */
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset= tmp;
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= tmp;
@@ -790,11 +790,11 @@
   if (type == OPT_GLOBAL)
   {
     bool not_used;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset=
       (size_t)getopt_ull_limit_value((size_t) option_limits->def_value,
                                      option_limits, &not_used);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= global_system_variables.*offset;
@@ -904,56 +904,56 @@
   case SHOW_INT:
   {
     uint32_t value;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     value= *(uint*) value_ptr(session, var_type, base);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return new Item_uint((uint64_t) value);
   }
   case SHOW_LONGLONG:
   {
     int64_t value;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     value= *(int64_t*) value_ptr(session, var_type, base);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return new Item_int(value);
   }
   case SHOW_DOUBLE:
   {
     double value;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     value= *(double*) value_ptr(session, var_type, base);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     /* 6, as this is for now only used with microseconds */
     return new Item_float(value, 6);
   }
   case SHOW_HA_ROWS:
   {
     ha_rows value;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     value= *(ha_rows*) value_ptr(session, var_type, base);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return new Item_int((uint64_t) value);
   }
   case SHOW_SIZE:
   {
     size_t value;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     value= *(size_t*) value_ptr(session, var_type, base);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return new Item_int((uint64_t) value);
   }
   case SHOW_MY_BOOL:
   {
     int32_t value;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     value= *(bool*) value_ptr(session, var_type, base);
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return new Item_int(value,1);
   }
   case SHOW_CHAR_PTR:
   {
     Item *tmp;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     char *str= *(char**) value_ptr(session, var_type, base);
     if (str)
     {
@@ -966,13 +966,13 @@
       tmp= new Item_null();
       tmp->collation.set(system_charset_info, DERIVATION_SYSCONST);
     }
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return tmp;
   }
   case SHOW_CHAR:
   {
     Item *tmp;
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     char *str= (char*) value_ptr(session, var_type, base);
     if (str)
       tmp= new Item_string(str, strlen(str),
@@ -982,7 +982,7 @@
       tmp= new Item_null();
       tmp->collation.set(system_charset_info, DERIVATION_SYSCONST);
     }
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
     return tmp;
   }
   default:
@@ -1185,9 +1185,9 @@
   /* We are using Time_zone object found during check() phase. */
   if (var->type == OPT_GLOBAL)
   {
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.time_zone= var->save_result.time_zone;
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.time_zone= var->save_result.time_zone;
@@ -1222,7 +1222,7 @@
 
 void sys_var_session_time_zone::set_default(Session *session, sql_var_t type)
 {
- pthread_mutex_lock(&LOCK_global_system_variables);
+ LOCK_global_system_variables.lock();
  if (type == OPT_GLOBAL)
  {
    if (default_tz_name)
@@ -1239,7 +1239,7 @@
  }
  else
    session->variables.time_zone= global_system_variables.time_zone;
- pthread_mutex_unlock(&LOCK_global_system_variables);
+ LOCK_global_system_variables.unlock();
 }
 
 
@@ -1328,9 +1328,9 @@
   microseconds= (int64_t) (num * 1000000.0 + 0.5);
   if (var->type == OPT_GLOBAL)
   {
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     (global_system_variables.*offset)= microseconds;
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= microseconds;
@@ -1343,9 +1343,9 @@
   int64_t microseconds= (int64_t) (option_limits->def_value * 1000000.0);
   if (type == OPT_GLOBAL)
   {
-    pthread_mutex_lock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.lock();
     global_system_variables.*offset= microseconds;
-    pthread_mutex_unlock(&LOCK_global_system_variables);
+    LOCK_global_system_variables.unlock();
   }
   else
     session->variables.*offset= microseconds;

=== modified file 'plugin/status_dictionary/status.cc'
--- plugin/status_dictionary/status.cc	2010-08-03 19:00:52 +0000
+++ plugin/status_dictionary/status.cc	2010-08-06 17:57:15 +0000
@@ -95,7 +95,7 @@
   std::ostringstream oss;
   std::string return_value;
 
-  pthread_mutex_lock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.lock();
 
   if (show_type == SHOW_SYS)
   {
@@ -106,7 +106,7 @@
 
   return_value= StatusHelper::fillHelper(NULL, value, show_type); 
 
-  pthread_mutex_unlock(&LOCK_global_system_variables);
+  LOCK_global_system_variables.unlock();
   push(name);
   if (return_value.length())
     push(return_value);

